package jbox.runtime;

import java.util.Set;

public class MsgSet {
	private Set<Msg> messages;
	private Object returnVal; // only for return message
	private Object[] args;
	
	public MsgSet(Set<Msg> messages, Object returnVal, Object[] args) {
		super();
		this.messages = messages;
		this.returnVal = returnVal;
		this.args = args;
	}
	
	public Set<Msg> getMessages() {
		return messages;
	}
	
	public Object[] getArgs() {
		return args;
	}
	
	public Object getReturnVal() {
		return returnVal;
	}

	@Override
	public String toString() {
		StringBuilder s = new StringBuilder();
		s.append("{\n");
		for (Msg m : messages) {
			s.append("  " + m + "\n");
		}
		s.append("}\n");
		return s.toString();
	}
	
}
