package jcs.checker;


public class Destination {
	int label; //stack modification depends on signum(label) here
	Guard guard;
	AbstractMsg msg;
	
	public Destination(AbstractMsg msg, int label, Guard guard) {
		this.msg = msg;
		this.label = label;
		this.guard = guard;
	}
	
	public AbstractMsg getMessage() {
		return msg;
	}
	
	public int getLabel() {
		return label;
	}
	
	public Guard getGuard() {
		return guard;
	}
}
