package jcs.types;

public class WildcardOneType extends Type {

	private static final WildcardOneType singleton = new WildcardOneType();
	
	private WildcardOneType() {}
	
	public static WildcardOneType instance() {
		return singleton;
	}
	
	@Override
	public boolean matches(Class<?> clazz) {
		return true;
	}

}
