package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface IdentifierNoneNd extends jcs.ast.gen.IdentifierOptNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.IdentifierNone> {

    //----- methods of IdentifierNoneNd -----

    public jcs.ast.gen.IdentifierNone termIdentifierOpt();
    public jcs.ast.gen.IdentifierNone term();
    public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i);
    public int size();
    public jcs.ast.gen.IdentifierNoneNd replace(jcs.ast.gen.IdentifierNone term);
    public jcs.ast.gen.JCS.TupleNd<?> parent();
    public jcs.ast.gen.JCS.SortNd lsib();
    public jcs.ast.gen.IdentifierNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierNoneNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierNoneNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.IdentifierNone> implements jcs.ast.gen.IdentifierNoneNd {

        //----- methods of Impl -----

        public jcs.ast.gen.IdentifierNone termIdentifierOpt() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.IdentifierNone term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort IdentifierNoneNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort IdentifierNoneNd invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.IdentifierNoneNd replace(jcs.ast.gen.IdentifierNone term) {
            return (jcs.ast.gen.IdentifierNoneNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.TupleNd<?> parent() {
            return (jcs.ast.gen.JCS.TupleNd<?>) super.parent();
        }

        public jcs.ast.gen.JCS.SortNd lsib() {
            return (jcs.ast.gen.JCS.SortNd) super.lsib();
        }

        public jcs.ast.gen.IdentifierNd rsib() {
            return (jcs.ast.gen.IdentifierNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierNoneNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IdentifierNoneNd";
        }
    }
}

