package katja.spec;

import katja.common.*;

public interface SelectorOpt extends KatjaSort {

    //----- methods of SelectorOpt -----

    public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SelectorOpt -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseSelector(katja.spec.Selector term) throws E;
        public CT CaseEmpty(katja.spec.Empty term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SelectorOpt.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }
    }
}

