package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface ExternTermSortDescriptors extends KatjaList<katja.spec.descriptors.ExternTermSortDescriptor> {

    //----- methods of ExternTermSortDescriptors -----

    public katja.spec.descriptors.ExternTermSortDescriptors add(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);
    public katja.spec.descriptors.ExternTermSortDescriptors remove(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);
    public katja.spec.descriptors.ExternTermSortDescriptors appBack(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors appFront(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);
    public katja.spec.descriptors.ExternTermSortDescriptors front();
    public katja.spec.descriptors.ExternTermSortDescriptors back();
    public katja.spec.descriptors.ExternTermSortDescriptors reverse();
    public katja.spec.descriptors.ExternTermSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.ExternTermSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.ExternTermSortDescriptors toSet();
    public katja.spec.descriptors.ExternTermSortDescriptors setAdd(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors setRemove(katja.spec.descriptors.ExternTermSortDescriptor element);
    public katja.spec.descriptors.ExternTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);
    public katja.spec.descriptors.ExternTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);
    public katja.spec.descriptors.ExternTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list);

    //----- nested classes of ExternTermSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitExternTermSortDescriptors(katja.spec.descriptors.ExternTermSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.ExternTermSortDescriptors.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.ExternTermSortDescriptor> implements katja.spec.descriptors.ExternTermSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.ExternTermSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.ExternTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternTermSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.ExternTermSortDescriptors createInstance(katja.spec.descriptors.ExternTermSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.ExternTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternTermSortDescriptors invoked with null element");

            ExternTermSortDescriptors.Impl temp = new katja.spec.descriptors.ExternTermSortDescriptors.Impl();
            temp.values = elements;
            temp = (ExternTermSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.ExternTermSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.ExternTermSortDescriptor[size];
        }

        public katja.spec.descriptors.ExternTermSortDescriptors add(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors remove(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors appBack(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors appFront(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors front() {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.front();
        }

        public katja.spec.descriptors.ExternTermSortDescriptors back() {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.back();
        }

        public katja.spec.descriptors.ExternTermSortDescriptors reverse() {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.ExternTermSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors toSet() {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.ExternTermSortDescriptors setAdd(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors setRemove(katja.spec.descriptors.ExternTermSortDescriptor element) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.ExternTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.ExternTermSortDescriptor> list) {
            return (katja.spec.descriptors.ExternTermSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.ExternTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.ExternTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ExternTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.ExternTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ExternTermSortDescriptors";
        }
    }
}

