package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface TupleParamPosList extends KatjaList<katja.spec.TupleParamPos> {

    //----- methods of TupleParamPosList -----

    public katja.spec.isabelle.TupleParamPosList add(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList addAll(KatjaList<? extends katja.spec.TupleParamPos> list);
    public katja.spec.isabelle.TupleParamPosList remove(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList removeAll(KatjaList<? extends katja.spec.TupleParamPos> list);
    public katja.spec.isabelle.TupleParamPosList appBack(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList appFront(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList conc(KatjaList<? extends katja.spec.TupleParamPos> list);
    public katja.spec.isabelle.TupleParamPosList front();
    public katja.spec.isabelle.TupleParamPosList back();
    public katja.spec.isabelle.TupleParamPosList reverse();
    public katja.spec.isabelle.TupleParamPosList sublist(int from, int to);
    public katja.spec.isabelle.TupleParamPosList replace(int ith, Object element);
    public katja.spec.isabelle.TupleParamPosList toSet();
    public katja.spec.isabelle.TupleParamPosList setAdd(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList setRemove(katja.spec.TupleParamPos element);
    public katja.spec.isabelle.TupleParamPosList setUnion(KatjaList<? extends katja.spec.TupleParamPos> list);
    public katja.spec.isabelle.TupleParamPosList setIntersection(KatjaList<? extends katja.spec.TupleParamPos> list);
    public katja.spec.isabelle.TupleParamPosList setWithout(KatjaList<? extends katja.spec.TupleParamPos> list);

    //----- nested classes of TupleParamPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPosList(katja.spec.isabelle.TupleParamPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.TupleParamPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.TupleParamPos> implements katja.spec.isabelle.TupleParamPosList {

        //----- methods of Impl -----

        Impl(katja.spec.TupleParamPos... elements) {
            super(elements);

            for(katja.spec.TupleParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleParamPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.isabelle.TupleParamPosList createInstance(katja.spec.TupleParamPos[] elements, boolean isSet) {
            for(katja.spec.TupleParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleParamPosList invoked with null element");

            TupleParamPosList.Impl temp = new katja.spec.isabelle.TupleParamPosList.Impl();
            temp.values = elements;
            temp = (TupleParamPosList.Impl) Isabelle.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.TupleParamPos[] createArray(int size) {
            return new katja.spec.TupleParamPos[size];
        }

        public katja.spec.isabelle.TupleParamPosList add(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.add(element);
        }

        public katja.spec.isabelle.TupleParamPosList addAll(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.addAll(list);
        }

        public katja.spec.isabelle.TupleParamPosList remove(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.remove(element);
        }

        public katja.spec.isabelle.TupleParamPosList removeAll(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.removeAll(list);
        }

        public katja.spec.isabelle.TupleParamPosList appBack(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.appBack(element);
        }

        public katja.spec.isabelle.TupleParamPosList appFront(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.appFront(element);
        }

        public katja.spec.isabelle.TupleParamPosList conc(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.conc(list);
        }

        public katja.spec.isabelle.TupleParamPosList front() {
            return (katja.spec.isabelle.TupleParamPosList) super.front();
        }

        public katja.spec.isabelle.TupleParamPosList back() {
            return (katja.spec.isabelle.TupleParamPosList) super.back();
        }

        public katja.spec.isabelle.TupleParamPosList reverse() {
            return (katja.spec.isabelle.TupleParamPosList) super.reverse();
        }

        public katja.spec.isabelle.TupleParamPosList sublist(int from, int to) {
            return (katja.spec.isabelle.TupleParamPosList) super.sublist(from, to);
        }

        public katja.spec.isabelle.TupleParamPosList replace(int ith, Object element) {
            return (katja.spec.isabelle.TupleParamPosList) super.replace(ith, element);
        }

        public katja.spec.isabelle.TupleParamPosList toSet() {
            return (katja.spec.isabelle.TupleParamPosList) super.toSet();
        }

        public katja.spec.isabelle.TupleParamPosList setAdd(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.setAdd(element);
        }

        public katja.spec.isabelle.TupleParamPosList setRemove(katja.spec.TupleParamPos element) {
            return (katja.spec.isabelle.TupleParamPosList) super.setRemove(element);
        }

        public katja.spec.isabelle.TupleParamPosList setUnion(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.setUnion(list);
        }

        public katja.spec.isabelle.TupleParamPosList setIntersection(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.setIntersection(list);
        }

        public katja.spec.isabelle.TupleParamPosList setWithout(KatjaList<? extends katja.spec.TupleParamPos> list) {
            return (katja.spec.isabelle.TupleParamPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Isabelle.TupleParamPosList");
            builder.append("( ");
            for(katja.spec.TupleParamPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TupleParamPosList");
            builder.append("( ");
            for(katja.spec.TupleParamPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TupleParamPosList";
        }
    }
}

