package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MAttributeInFile extends katja.spec.model.Model.TupleInFile<katja.spec.model.MAttribute> {

    //----- methods of MAttributeInFile -----

    public katja.spec.model.MAttribute term();
    public katja.spec.model.MModifiersInFile modifiers();
    public katja.spec.model.MAttributeInFile replaceModifiers(katja.spec.model.MModifiers modifiers);
    public katja.spec.model.MAnyTypeInFile type();
    public katja.spec.model.MAttributeInFile replaceType(katja.spec.model.MAnyType type);
    public katja.spec.model.StringInFile name();
    public katja.spec.model.MAttributeInFile replaceName(java.lang.String name);
    public katja.spec.model.MCodeFragmentInFile initial();
    public katja.spec.model.MAttributeInFile replaceInitial(katja.spec.model.MCodeFragment initial);
    public katja.spec.model.Model.SortInFile get(int i);
    public int size();
    public katja.spec.model.MAttributeInFile replace(katja.spec.model.MAttribute term);
    public katja.spec.model.MAttributesInFile parent();
    public katja.spec.model.MAttributeInFile lsib();
    public katja.spec.model.MAttributeInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MAttributeInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifiersInFile(katja.spec.model.MModifiersInFile term) throws E;
        public void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMCodeFragmentInFile(katja.spec.model.MCodeFragmentInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E;
        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E;
        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitPROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E;
        public void visitPRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E;
        public void visitPUBLICInFile(katja.spec.model.PUBLICInFile term) throws E;
        public void visitSTATICInFile(katja.spec.model.STATICInFile term) throws E;
        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E;
        public void visitFINALInFile(katja.spec.model.FINALInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMAttributeInFile(katja.spec.model.MAttributeInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MAttributeInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyTypeInFile.Switch<Object, E> variantVisit$MAnyTypeInFile = new katja.spec.model.MAnyTypeInFile.Switch<Object, E>() { public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MModifierInFile.Switch<Object, E> variantVisit$MModifierInFile = new katja.spec.model.MModifierInFile.Switch<Object, E>() { public final Object CasePROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E { visitPROTECTEDInFile(term); return null; } public final Object CasePRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E { visitPRIVATEInFile(term); return null; } public final Object CasePUBLICInFile(katja.spec.model.PUBLICInFile term) throws E { visitPUBLICInFile(term); return null; } public final Object CaseSTATICInFile(katja.spec.model.STATICInFile term) throws E { visitSTATICInFile(term); return null; } public final Object CaseABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E { visitABSTRACTInFile(term); return null; } public final Object CaseFINALInFile(katja.spec.model.FINALInFile term) throws E { visitFINALInFile(term); return null; } };
        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E {
            term.Switch(variantVisit$MAnyTypeInFile);
        }

        public final void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E {
            term.Switch(variantVisit$MModifierInFile);
        }

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MAnyTypeInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MAnyTypeInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MAttribute> implements katja.spec.model.MAttributeInFile {

        //----- attributes of Impl -----

        private katja.spec.model.MModifiersInFile _modifiers = null;
        private katja.spec.model.MAnyTypeInFile _type = null;
        private katja.spec.model.StringInFile _name = null;
        private katja.spec.model.MCodeFragmentInFile _initial = null;

        //----- methods of Impl -----

        public katja.spec.model.MModifiersInFile modifiers() {
            if(_modifiers == null)
                _modifiers = katja.spec.model.Model.MModifiersInFile(this, _term.modifiers(), 0);

            return _modifiers;
        }

        public katja.spec.model.MAttributeInFile replaceModifiers(katja.spec.model.MModifiers modifiers) {
            return replace(_term.replaceModifiers(modifiers));
        }

        public katja.spec.model.MAnyTypeInFile type() {
            if(_type == null)
                _type = katja.spec.model.Model.MAnyTypeInFile(this, _term.type(), 1);

            return _type;
        }

        public katja.spec.model.MAttributeInFile replaceType(katja.spec.model.MAnyType type) {
            return replace(_term.replaceType(type));
        }

        public katja.spec.model.StringInFile name() {
            if(_name == null)
                _name = katja.spec.model.Model.StringInFile(this, _term.name(), 2);

            return _name;
        }

        public katja.spec.model.MAttributeInFile replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.model.MCodeFragmentInFile initial() {
            if(_initial == null)
                _initial = katja.spec.model.Model.MCodeFragmentInFile(this, _term.initial(), 3);

            return _initial;
        }

        public katja.spec.model.MAttributeInFile replaceInitial(katja.spec.model.MCodeFragment initial) {
            return replace(_term.replaceInitial(initial));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MAttribute term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.SortInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0:
                    if(_modifiers == null)
                        _modifiers = Model.MModifiersInFile(this, _term.modifiers(), 0);
                    
                    return _modifiers;
                case 1:
                    if(_type == null)
                        _type = Model.MAnyTypeInFile(this, _term.type(), 1);
                    
                    return _type;
                case 2:
                    if(_name == null)
                        _name = Model.StringInFile(this, _term.name(), 2);
                    
                    return _name;
                case 3:
                    if(_initial == null)
                        _initial = Model.MCodeFragmentInFile(this, _term.initial(), 3);
                    
                    return _initial;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MAttributeInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MAttributeInFile invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.model.MAttributeInFile replace(katja.spec.model.MAttribute term) {
            return (katja.spec.model.MAttributeInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MAttributesInFile parent() {
            return (katja.spec.model.MAttributesInFile) super.parent();
        }

        public katja.spec.model.MAttributeInFile lsib() {
            return (katja.spec.model.MAttributeInFile) super.lsib();
        }

        public katja.spec.model.MAttributeInFile rsib() {
            return (katja.spec.model.MAttributeInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MAttributeInFile";
        }
    }
}

