package katja.spec.model;

import katja.common.*;

public interface MClassType extends KatjaSort {

    //----- methods of MClassType -----

    public <CT, E extends Throwable> CT Switch(katja.spec.model.MClassType.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MClassType -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseINTERFACE(katja.spec.model.INTERFACE term) throws E;
        public CT CaseCLASS(katja.spec.model.CLASS term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMClassType(katja.spec.model.MClassType term) throws E;
        public void visitINTERFACE(katja.spec.model.INTERFACE term) throws E;
        public void visitCLASS(katja.spec.model.CLASS term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MClassType.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MClassType.Switch<Object, E> variantVisit$MClassType = new katja.spec.model.MClassType.Switch<Object, E>() { public final Object CaseINTERFACE(katja.spec.model.INTERFACE term) throws E { visitINTERFACE(term); return null; } public final Object CaseCLASS(katja.spec.model.CLASS term) throws E { visitCLASS(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMClassType(katja.spec.model.MClassType term) throws E {
            term.Switch(variantVisit$MClassType);
        }
    }
}

