package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MGenericTypeAppInFile extends katja.spec.model.MTypeInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MGenericTypeApp> {

    //----- methods of MGenericTypeAppInFile -----

    public katja.spec.model.MGenericTypeApp termMType();
    public katja.spec.model.MGenericTypeApp termMAnyType();
    public katja.spec.model.MGenericTypeApp termMTypeOrWildcard();
    public katja.spec.model.MGenericTypeApp termMParamtype();
    public katja.spec.model.MGenericTypeApp termMReturnType();
    public katja.spec.model.MGenericTypeApp termMParamtypeDecl();
    public katja.spec.model.MGenericTypeApp term();
    public katja.spec.model.MNonGenericTypeInFile type();
    public katja.spec.model.MGenericTypeAppInFile replaceType(katja.spec.model.MNonGenericType type);
    public katja.spec.model.MTypeOrWildcardsInFile types();
    public katja.spec.model.MGenericTypeAppInFile replaceTypes(katja.spec.model.MTypeOrWildcards types);
    public katja.spec.model.Model.SortInFile get(int i);
    public int size();
    public katja.spec.model.MGenericTypeAppInFile replace(katja.spec.model.MGenericTypeApp term);
    public katja.spec.model.Model.NodeInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MGenericTypeAppInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MGenericTypeAppInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MGenericTypeApp> implements katja.spec.model.MGenericTypeAppInFile {

        //----- attributes of Impl -----

        private katja.spec.model.MNonGenericTypeInFile _type = null;
        private katja.spec.model.MTypeOrWildcardsInFile _types = null;

        //----- methods of Impl -----

        public katja.spec.model.MGenericTypeApp termMType() {
            return term();
        }

        public katja.spec.model.MGenericTypeApp termMAnyType() {
            return term();
        }

        public katja.spec.model.MGenericTypeApp termMTypeOrWildcard() {
            return term();
        }

        public katja.spec.model.MGenericTypeApp termMParamtype() {
            return term();
        }

        public katja.spec.model.MGenericTypeApp termMReturnType() {
            return term();
        }

        public katja.spec.model.MGenericTypeApp termMParamtypeDecl() {
            return term();
        }

        public katja.spec.model.MNonGenericTypeInFile type() {
            if(_type == null)
                _type = katja.spec.model.Model.MNonGenericTypeInFile(this, _term.type(), 0);

            return _type;
        }

        public katja.spec.model.MGenericTypeAppInFile replaceType(katja.spec.model.MNonGenericType type) {
            return replace(_term.replaceType(type));
        }

        public katja.spec.model.MTypeOrWildcardsInFile types() {
            if(_types == null)
                _types = katja.spec.model.Model.MTypeOrWildcardsInFile(this, _term.types(), 1);

            return _types;
        }

        public katja.spec.model.MGenericTypeAppInFile replaceTypes(katja.spec.model.MTypeOrWildcards types) {
            return replace(_term.replaceTypes(types));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MGenericTypeApp term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.SortInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_type == null)
                        _type = Model.MNonGenericTypeInFile(this, _term.type(), 0);
                    
                    return _type;
                case 1:
                    if(_types == null)
                        _types = Model.MTypeOrWildcardsInFile(this, _term.types(), 1);
                    
                    return _types;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MGenericTypeAppInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MGenericTypeAppInFile invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MGenericTypeAppInFile replace(katja.spec.model.MGenericTypeApp term) {
            return (katja.spec.model.MGenericTypeAppInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.NodeInFile<?> parent() {
            return (katja.spec.model.Model.NodeInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeAppInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MGenericTypeAppInFile";
        }
    }
}

