package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MKatjaTypeInFile extends katja.spec.model.MNonGenericTypeInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MKatjaType> {

    //----- methods of MKatjaTypeInFile -----

    public katja.spec.model.MKatjaType termMNonGenericType();
    public katja.spec.model.MKatjaType termMType();
    public katja.spec.model.MKatjaType termMAnyType();
    public katja.spec.model.MKatjaType termMTypeOrWildcard();
    public katja.spec.model.MKatjaType termMParamtype();
    public katja.spec.model.MKatjaType termMReturnType();
    public katja.spec.model.MKatjaType termMParamtypeDecl();
    public katja.spec.model.MKatjaType term();
    public katja.spec.model.SortDescriptorInFile sortDesc();
    public katja.spec.model.MKatjaTypeInFile replaceSortDesc(katja.spec.descriptors.SortDescriptor sortDesc);
    public katja.spec.model.SortDescriptorInFile get(int i);
    public int size();
    public katja.spec.model.MKatjaTypeInFile replace(katja.spec.model.MKatjaType term);
    public katja.spec.model.Model.NodeInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MKatjaTypeInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MKatjaTypeInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MKatjaType> implements katja.spec.model.MKatjaTypeInFile {

        //----- attributes of Impl -----

        private katja.spec.model.SortDescriptorInFile _sortDesc = null;

        //----- methods of Impl -----

        public katja.spec.model.MKatjaType termMNonGenericType() {
            return term();
        }

        public katja.spec.model.MKatjaType termMType() {
            return term();
        }

        public katja.spec.model.MKatjaType termMAnyType() {
            return term();
        }

        public katja.spec.model.MKatjaType termMTypeOrWildcard() {
            return term();
        }

        public katja.spec.model.MKatjaType termMParamtype() {
            return term();
        }

        public katja.spec.model.MKatjaType termMReturnType() {
            return term();
        }

        public katja.spec.model.MKatjaType termMParamtypeDecl() {
            return term();
        }

        public katja.spec.model.SortDescriptorInFile sortDesc() {
            if(_sortDesc == null)
                _sortDesc = katja.spec.model.Model.SortDescriptorInFile(this, _term.sortDesc(), 0);

            return _sortDesc;
        }

        public katja.spec.model.MKatjaTypeInFile replaceSortDesc(katja.spec.descriptors.SortDescriptor sortDesc) {
            return replace(_term.replaceSortDesc(sortDesc));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MKatjaType term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.SortDescriptorInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_sortDesc == null)
                        _sortDesc = Model.SortDescriptorInFile(this, _term.sortDesc(), 0);
                    
                    return _sortDesc;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MKatjaTypeInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MKatjaTypeInFile invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.model.MKatjaTypeInFile replace(katja.spec.model.MKatjaType term) {
            return (katja.spec.model.MKatjaTypeInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.NodeInFile<?> parent() {
            return (katja.spec.model.Model.NodeInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaTypeInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MKatjaTypeInFile";
        }
    }
}

