package katja.spec.model;

import katja.common.*;

public interface MModifier extends KatjaSort {

    //----- methods of MModifier -----

    public <CT, E extends Throwable> CT Switch(katja.spec.model.MModifier.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MModifier -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CasePROTECTED(katja.spec.model.PROTECTED term) throws E;
        public CT CasePRIVATE(katja.spec.model.PRIVATE term) throws E;
        public CT CasePUBLIC(katja.spec.model.PUBLIC term) throws E;
        public CT CaseSTATIC(katja.spec.model.STATIC term) throws E;
        public CT CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public CT CaseFINAL(katja.spec.model.FINAL term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MModifier.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }
    }
}

