package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MModifiers extends KatjaList<katja.spec.model.MModifier> {

    //----- methods of MModifiers -----

    public katja.spec.model.MModifiers add(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers addAll(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiers remove(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers removeAll(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiers appBack(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers appFront(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers conc(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiers front();
    public katja.spec.model.MModifiers back();
    public katja.spec.model.MModifiers reverse();
    public katja.spec.model.MModifiers sublist(int from, int to);
    public katja.spec.model.MModifiers replace(int ith, Object element);
    public katja.spec.model.MModifiers toSet();
    public katja.spec.model.MModifiers setAdd(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers setRemove(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiers setUnion(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiers setIntersection(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiers setWithout(KatjaList<? extends katja.spec.model.MModifier> list);

    //----- nested classes of MModifiers -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MModifiers.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MModifier> implements katja.spec.model.MModifiers {

        //----- methods of Impl -----

        Impl(katja.spec.model.MModifier... elements) {
            super(elements);

            for(katja.spec.model.MModifier element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MModifiers invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MModifiers createInstance(katja.spec.model.MModifier[] elements, boolean isSet) {
            for(katja.spec.model.MModifier element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MModifiers invoked with null element");

            MModifiers.Impl temp = new katja.spec.model.MModifiers.Impl();
            temp.values = elements;
            temp = (MModifiers.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MModifier[] createArray(int size) {
            return new katja.spec.model.MModifier[size];
        }

        public katja.spec.model.MModifiers add(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.add(element);
        }

        public katja.spec.model.MModifiers addAll(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.addAll(list);
        }

        public katja.spec.model.MModifiers remove(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.remove(element);
        }

        public katja.spec.model.MModifiers removeAll(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.removeAll(list);
        }

        public katja.spec.model.MModifiers appBack(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.appBack(element);
        }

        public katja.spec.model.MModifiers appFront(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.appFront(element);
        }

        public katja.spec.model.MModifiers conc(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.conc(list);
        }

        public katja.spec.model.MModifiers front() {
            return (katja.spec.model.MModifiers) super.front();
        }

        public katja.spec.model.MModifiers back() {
            return (katja.spec.model.MModifiers) super.back();
        }

        public katja.spec.model.MModifiers reverse() {
            return (katja.spec.model.MModifiers) super.reverse();
        }

        public katja.spec.model.MModifiers sublist(int from, int to) {
            return (katja.spec.model.MModifiers) super.sublist(from, to);
        }

        public katja.spec.model.MModifiers replace(int ith, Object element) {
            return (katja.spec.model.MModifiers) super.replace(ith, element);
        }

        public katja.spec.model.MModifiers toSet() {
            return (katja.spec.model.MModifiers) super.toSet();
        }

        public katja.spec.model.MModifiers setAdd(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.setAdd(element);
        }

        public katja.spec.model.MModifiers setRemove(katja.spec.model.MModifier element) {
            return (katja.spec.model.MModifiers) super.setRemove(element);
        }

        public katja.spec.model.MModifiers setUnion(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.setUnion(list);
        }

        public katja.spec.model.MModifiers setIntersection(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.setIntersection(list);
        }

        public katja.spec.model.MModifiers setWithout(KatjaList<? extends katja.spec.model.MModifier> list) {
            return (katja.spec.model.MModifiers) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MModifiers");
            builder.append("( ");
            for(katja.spec.model.MModifier element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MModifiers");
            builder.append("( ");
            for(katja.spec.model.MModifier element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MModifiers";
        }
    }
}

