package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MModifiersInFile extends katja.spec.model.Model.ListInFile<katja.spec.model.MModifiers, katja.spec.model.MModifierInFile, katja.spec.model.MModifier> {

    //----- methods of MModifiersInFile -----

    public katja.spec.model.MModifiers term();
    public katja.spec.model.MModifiersInFile add(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile addAll(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiersInFile remove(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile removeAll(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiersInFile appBack(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile appFront(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile conc(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiersInFile reverse();
    public katja.spec.model.MModifiersInFile toSet();
    public katja.spec.model.MModifiersInFile setAdd(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile setRemove(katja.spec.model.MModifier element);
    public katja.spec.model.MModifiersInFile setUnion(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiersInFile setWithout(KatjaList<? extends katja.spec.model.MModifier> list);
    public katja.spec.model.MModifiersInFile setIntersection(KatjaList<? extends katja.spec.model.MModifier> list);
    public KatjaList<katja.spec.model.MModifierInFile> toList();
    public katja.spec.model.MModifiersInFile replace(katja.spec.model.MModifiers term);
    public katja.spec.model.Model.TupleInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MModifiersInFile -----

    static class ListImpl extends KatjaListImpl<katja.spec.model.MModifierInFile> implements KatjaList<katja.spec.model.MModifierInFile> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.model.MModifierInFile... elements) {
            super(elements);

            for(katja.spec.model.MModifierInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MModifierInFile invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.model.MModifierInFile> createInstance(katja.spec.model.MModifierInFile[] elements, boolean isSet) {
            for(katja.spec.model.MModifierInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MModifierInFile invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MModifierInFile[] createArray(int size) {
            return new katja.spec.model.MModifierInFile[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.model.MModifierInFile element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E;
        public void visitPROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E;
        public void visitPRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E;
        public void visitPUBLICInFile(katja.spec.model.PUBLICInFile term) throws E;
        public void visitSTATICInFile(katja.spec.model.STATICInFile term) throws E;
        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E;
        public void visitFINALInFile(katja.spec.model.FINALInFile term) throws E;
        public void visitMModifiersInFile(katja.spec.model.MModifiersInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MModifiersInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MModifierInFile.Switch<Object, E> variantVisit$MModifierInFile = new katja.spec.model.MModifierInFile.Switch<Object, E>() { public final Object CasePROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E { visitPROTECTEDInFile(term); return null; } public final Object CasePRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E { visitPRIVATEInFile(term); return null; } public final Object CasePUBLICInFile(katja.spec.model.PUBLICInFile term) throws E { visitPUBLICInFile(term); return null; } public final Object CaseSTATICInFile(katja.spec.model.STATICInFile term) throws E { visitSTATICInFile(term); return null; } public final Object CaseABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E { visitABSTRACTInFile(term); return null; } public final Object CaseFINALInFile(katja.spec.model.FINALInFile term) throws E { visitFINALInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E {
            term.Switch(variantVisit$MModifierInFile);
        }
    }

    static class Impl extends KatjaListPosImpl<katja.spec.model.MFileInFile, katja.spec.model.MModifiers, katja.spec.model.MModifierInFile, katja.spec.model.MModifier> implements katja.spec.model.MModifiersInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MModifiers term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.MModifierInFile getElementInstance(int pos) {
            return katja.spec.model.Model.MModifierInFile(this, _term.get(pos), pos);
        }

        protected katja.spec.model.MModifierInFile[] createArray(int size) {
            return new katja.spec.model.MModifierInFile[size];
        }

        public katja.spec.model.MModifiersInFile add(katja.spec.model.MModifier element) {
            return replace(_term.add(element));
        }

        public katja.spec.model.MModifiersInFile addAll(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.model.MModifiersInFile remove(katja.spec.model.MModifier element) {
            return replace(_term.remove(element));
        }

        public katja.spec.model.MModifiersInFile removeAll(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.model.MModifiersInFile appBack(katja.spec.model.MModifier element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.model.MModifiersInFile appFront(katja.spec.model.MModifier element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.model.MModifiersInFile conc(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.model.MModifiersInFile reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.model.MModifiersInFile toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.model.MModifiersInFile setAdd(katja.spec.model.MModifier element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.model.MModifiersInFile setRemove(katja.spec.model.MModifier element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.model.MModifiersInFile setUnion(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.model.MModifiersInFile setWithout(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.model.MModifiersInFile setIntersection(KatjaList<? extends katja.spec.model.MModifier> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.model.MModifierInFile> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new MModifiersInFile.ListImpl(values);
        }

        public katja.spec.model.MModifiersInFile replace(katja.spec.model.MModifiers term) {
            return (katja.spec.model.MModifiersInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.TupleInFile<?> parent() {
            return (katja.spec.model.Model.TupleInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MModifiersInFile";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.model.MModifierInFile> implements KatjaList<katja.spec.model.MModifierInFile> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.model.MModifierInFile... elements) {
                super(elements);

                for(katja.spec.model.MModifierInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MModifierInFile invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.model.MModifierInFile> createInstance(katja.spec.model.MModifierInFile[] elements, boolean isSet) {
                for(katja.spec.model.MModifierInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MModifierInFile invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Model.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.model.MModifierInFile[] createArray(int size) {
                return new katja.spec.model.MModifierInFile[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.model.MModifierInFile element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

