package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MParameter extends KatjaTuple {

    //----- methods of MParameter -----

    public katja.spec.model.MParamtypeDecl decl();
    public katja.spec.model.MParameter replaceDecl(katja.spec.model.MParamtypeDecl decl);
    public java.lang.String name();
    public katja.spec.model.MParameter replaceName(java.lang.String name);
    public Object get(int i);
    public int size();
    public katja.spec.model.MParameter replace(int pos, Object term);

    //----- nested classes of MParameter -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMParamtype(katja.spec.model.MParamtype term) throws E;
        public void visitMFinal(katja.spec.model.MFinal term) throws E;
        public void visitMVararg(katja.spec.model.MVararg term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMParameter(katja.spec.model.MParameter term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MParameter.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtype.Switch<Object, E> variantVisit$MParamtype = new katja.spec.model.MParamtype.Switch<Object, E>() { public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtypeDecl.Switch<Object, E> variantVisit$MParamtypeDecl = new katja.spec.model.MParamtypeDecl.Switch<Object, E>() { public final Object CaseMFinal(katja.spec.model.MFinal term) throws E { visitMFinal(term); return null; } public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMParamtype(katja.spec.model.MParamtype term) throws E {
            term.Switch(variantVisit$MParamtype);
        }

        public final void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MParameter {

        //----- attributes of Impl -----

        private katja.spec.model.MParamtypeDecl _decl = null;
        private java.lang.String _name = null;

        //----- methods of Impl -----

        public katja.spec.model.MParamtypeDecl decl() {
            return _decl;
        }

        public katja.spec.model.MParameter replaceDecl(katja.spec.model.MParamtypeDecl decl) {
            return replace(0, decl);
        }

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.model.MParameter replaceName(java.lang.String name) {
            return replace(1, name);
        }

        Impl(katja.spec.model.MParamtypeDecl decl, java.lang.String name) {
            if(decl == null)
                throw new IllegalArgumentException("constructor of sort MParameter invoked with null parameter decl");
            if(name == null)
                throw new IllegalArgumentException("constructor of sort MParameter invoked with null parameter name");

            this._decl = decl;
            this._name = name;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _decl;
                case 1: return _name;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MParameter invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MParameter invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MParameter replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MParameter invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort MParameter invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MParamtypeDecl))
                throw new IllegalArgumentException("replace on sort MParameter invoked with term of incorrect sort, MParamtypeDecl expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MParameter invoked with term of incorrect sort, String expected");

            return (katja.spec.model.MParameter) Model.unique(new katja.spec.model.MParameter.Impl(
                pos == 0 ? (katja.spec.model.MParamtypeDecl) term : _decl,
                pos == 1 ? (java.lang.String) term : _name
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MParameter");
            builder.append("( ");
            _decl.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MParameter");
            builder.append("( ");
            _decl.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MParameter";
        }
    }
}

