package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MTypeVariables extends KatjaList<katja.spec.model.MTypeVariable> {

    //----- methods of MTypeVariables -----

    public katja.spec.model.MTypeVariables add(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables addAll(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariables remove(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables removeAll(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariables appBack(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables appFront(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables conc(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariables front();
    public katja.spec.model.MTypeVariables back();
    public katja.spec.model.MTypeVariables reverse();
    public katja.spec.model.MTypeVariables sublist(int from, int to);
    public katja.spec.model.MTypeVariables replace(int ith, Object element);
    public katja.spec.model.MTypeVariables toSet();
    public katja.spec.model.MTypeVariables setAdd(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables setRemove(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariables setUnion(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariables setIntersection(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariables setWithout(KatjaList<? extends katja.spec.model.MTypeVariable> list);

    //----- nested classes of MTypeVariables -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMTypeVariable(katja.spec.model.MTypeVariable term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMTypeVariables(katja.spec.model.MTypeVariables term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MTypeVariables.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MTypeVariable> implements katja.spec.model.MTypeVariables {

        //----- methods of Impl -----

        Impl(katja.spec.model.MTypeVariable... elements) {
            super(elements);

            for(katja.spec.model.MTypeVariable element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MTypeVariables invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MTypeVariables createInstance(katja.spec.model.MTypeVariable[] elements, boolean isSet) {
            for(katja.spec.model.MTypeVariable element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MTypeVariables invoked with null element");

            MTypeVariables.Impl temp = new katja.spec.model.MTypeVariables.Impl();
            temp.values = elements;
            temp = (MTypeVariables.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MTypeVariable[] createArray(int size) {
            return new katja.spec.model.MTypeVariable[size];
        }

        public katja.spec.model.MTypeVariables add(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.add(element);
        }

        public katja.spec.model.MTypeVariables addAll(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.addAll(list);
        }

        public katja.spec.model.MTypeVariables remove(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.remove(element);
        }

        public katja.spec.model.MTypeVariables removeAll(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.removeAll(list);
        }

        public katja.spec.model.MTypeVariables appBack(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.appBack(element);
        }

        public katja.spec.model.MTypeVariables appFront(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.appFront(element);
        }

        public katja.spec.model.MTypeVariables conc(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.conc(list);
        }

        public katja.spec.model.MTypeVariables front() {
            return (katja.spec.model.MTypeVariables) super.front();
        }

        public katja.spec.model.MTypeVariables back() {
            return (katja.spec.model.MTypeVariables) super.back();
        }

        public katja.spec.model.MTypeVariables reverse() {
            return (katja.spec.model.MTypeVariables) super.reverse();
        }

        public katja.spec.model.MTypeVariables sublist(int from, int to) {
            return (katja.spec.model.MTypeVariables) super.sublist(from, to);
        }

        public katja.spec.model.MTypeVariables replace(int ith, Object element) {
            return (katja.spec.model.MTypeVariables) super.replace(ith, element);
        }

        public katja.spec.model.MTypeVariables toSet() {
            return (katja.spec.model.MTypeVariables) super.toSet();
        }

        public katja.spec.model.MTypeVariables setAdd(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.setAdd(element);
        }

        public katja.spec.model.MTypeVariables setRemove(katja.spec.model.MTypeVariable element) {
            return (katja.spec.model.MTypeVariables) super.setRemove(element);
        }

        public katja.spec.model.MTypeVariables setUnion(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.setUnion(list);
        }

        public katja.spec.model.MTypeVariables setIntersection(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.setIntersection(list);
        }

        public katja.spec.model.MTypeVariables setWithout(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return (katja.spec.model.MTypeVariables) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MTypeVariables");
            builder.append("( ");
            for(katja.spec.model.MTypeVariable element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MTypeVariables");
            builder.append("( ");
            for(katja.spec.model.MTypeVariable element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MTypeVariables";
        }
    }
}

