package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MTypeVariablesInFile extends katja.spec.model.Model.ListInFile<katja.spec.model.MTypeVariables, katja.spec.model.MTypeVariableInFile, katja.spec.model.MTypeVariable> {

    //----- methods of MTypeVariablesInFile -----

    public katja.spec.model.MTypeVariables term();
    public katja.spec.model.MTypeVariablesInFile add(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile addAll(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariablesInFile remove(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile removeAll(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariablesInFile appBack(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile appFront(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile conc(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariablesInFile reverse();
    public katja.spec.model.MTypeVariablesInFile toSet();
    public katja.spec.model.MTypeVariablesInFile setAdd(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile setRemove(katja.spec.model.MTypeVariable element);
    public katja.spec.model.MTypeVariablesInFile setUnion(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariablesInFile setWithout(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public katja.spec.model.MTypeVariablesInFile setIntersection(KatjaList<? extends katja.spec.model.MTypeVariable> list);
    public KatjaList<katja.spec.model.MTypeVariableInFile> toList();
    public katja.spec.model.MTypeVariablesInFile replace(katja.spec.model.MTypeVariables term);
    public katja.spec.model.Model.TupleInFile<?> parent();
    public katja.spec.model.Model.NodeInFile<?> lsib();
    public katja.spec.model.MReturnTypeInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MTypeVariablesInFile -----

    static class ListImpl extends KatjaListImpl<katja.spec.model.MTypeVariableInFile> implements KatjaList<katja.spec.model.MTypeVariableInFile> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.model.MTypeVariableInFile... elements) {
            super(elements);

            for(katja.spec.model.MTypeVariableInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MTypeVariableInFile invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.model.MTypeVariableInFile> createInstance(katja.spec.model.MTypeVariableInFile[] elements, boolean isSet) {
            for(katja.spec.model.MTypeVariableInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MTypeVariableInFile invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MTypeVariableInFile[] createArray(int size) {
            return new katja.spec.model.MTypeVariableInFile[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.model.MTypeVariableInFile element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMTypeVariableInFile(katja.spec.model.MTypeVariableInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMTypeVariablesInFile(katja.spec.model.MTypeVariablesInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MTypeVariablesInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaListPosImpl<katja.spec.model.MFileInFile, katja.spec.model.MTypeVariables, katja.spec.model.MTypeVariableInFile, katja.spec.model.MTypeVariable> implements katja.spec.model.MTypeVariablesInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MTypeVariables term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.MTypeVariableInFile getElementInstance(int pos) {
            return katja.spec.model.Model.MTypeVariableInFile(this, _term.get(pos), pos);
        }

        protected katja.spec.model.MTypeVariableInFile[] createArray(int size) {
            return new katja.spec.model.MTypeVariableInFile[size];
        }

        public katja.spec.model.MTypeVariablesInFile add(katja.spec.model.MTypeVariable element) {
            return replace(_term.add(element));
        }

        public katja.spec.model.MTypeVariablesInFile addAll(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.model.MTypeVariablesInFile remove(katja.spec.model.MTypeVariable element) {
            return replace(_term.remove(element));
        }

        public katja.spec.model.MTypeVariablesInFile removeAll(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.model.MTypeVariablesInFile appBack(katja.spec.model.MTypeVariable element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.model.MTypeVariablesInFile appFront(katja.spec.model.MTypeVariable element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.model.MTypeVariablesInFile conc(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.model.MTypeVariablesInFile reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.model.MTypeVariablesInFile toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.model.MTypeVariablesInFile setAdd(katja.spec.model.MTypeVariable element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.model.MTypeVariablesInFile setRemove(katja.spec.model.MTypeVariable element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.model.MTypeVariablesInFile setUnion(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.model.MTypeVariablesInFile setWithout(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.model.MTypeVariablesInFile setIntersection(KatjaList<? extends katja.spec.model.MTypeVariable> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.model.MTypeVariableInFile> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new MTypeVariablesInFile.ListImpl(values);
        }

        public katja.spec.model.MTypeVariablesInFile replace(katja.spec.model.MTypeVariables term) {
            return (katja.spec.model.MTypeVariablesInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.TupleInFile<?> parent() {
            return (katja.spec.model.Model.TupleInFile<?>) super.parent();
        }

        public katja.spec.model.Model.NodeInFile<?> lsib() {
            return (katja.spec.model.Model.NodeInFile<?>) super.lsib();
        }

        public katja.spec.model.MReturnTypeInFile rsib() {
            return (katja.spec.model.MReturnTypeInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MTypeVariablesInFile";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.model.MTypeVariableInFile> implements KatjaList<katja.spec.model.MTypeVariableInFile> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.model.MTypeVariableInFile... elements) {
                super(elements);

                for(katja.spec.model.MTypeVariableInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MTypeVariableInFile invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.model.MTypeVariableInFile> createInstance(katja.spec.model.MTypeVariableInFile[] elements, boolean isSet) {
                for(katja.spec.model.MTypeVariableInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MTypeVariableInFile invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Model.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.model.MTypeVariableInFile[] createArray(int size) {
                return new katja.spec.model.MTypeVariableInFile[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.model.MTypeVariableInFile element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

