package katja.spec.model;

import katja.common.*;

public interface TermSortDescriptorInFile extends katja.spec.model.SortDescriptorInFile, katja.spec.model.Model.SortInFile {

    //----- methods of TermSortDescriptorInFile -----

    public katja.spec.descriptors.TermSortDescriptor termSortDescriptor();
    public KatjaSort term();
    public katja.spec.descriptors.TermSortDescriptor termTermSortDescriptor();
    public <CT, E extends Throwable> CT Switch(katja.spec.model.TermSortDescriptorInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TermSortDescriptorInFile -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public CT CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public CT CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public CT CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.TermSortDescriptorInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.TermSortDescriptorInFile.Switch<Object, E> variantVisit$TermSortDescriptorInFile = new katja.spec.model.TermSortDescriptorInFile.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$TermSortDescriptorInFile);
        }
    }
}

