package jbox.agent;

//TODO: make this handler more intelligent :-)
public class Handler {
	private static IHandler handler;
	private static Thread thread;
	private static boolean inHandler = false;
	
	public static void setHandler(IHandler handler, Thread t) {
		Handler.handler = handler;
		thread = t;
	}
	
	
	private static boolean guardIn() {
		if (!inHandler && handler != null && Thread.currentThread() == thread && !Agent.isAgentActive) {
			inHandler = true;
			return false;
		}
		return true;
	}
	
	private static void guardOut() {
		inHandler = false;
	}
	
	public static void onNewObject(Object o) {
		if (guardIn()) return;
		handler.onNewObject(o);
		guardOut();
	}
	
	public static void onMethodEnter(Object newthis, Object[] args, String className, String methodName, String sig){
		if (guardIn()) return;
		handler.onMethodEnter(newthis, args, className, methodName, sig);
		guardOut();
	}

	

	public static void onMethodExit(Object returnVal, Object oldthis, Object[] args, String className, String methodName, String sig){
		if (guardIn()) return;
		handler.onMethodExit(returnVal, oldthis, args, className, methodName, sig);
		guardOut();
	}

	public static void nextObjectNewBox(String intfClass, String specHandler, String spec){
		if (guardIn()) return;
		handler.nextObjectNewBox(intfClass, specHandler, spec);
		guardOut();
	}

	public static void onFieldAccess(Object o){
		if (guardIn()) return;
		handler.onFieldAccess(o);
		guardOut();
	}

	/*public static void onMethodCall(Object o, String owner, String name, String desc){
		if (guardIn()) return;
		handler.onMethodCall(o, owner, name, desc);
		guardOut();
	}*/
	
	/*public static void onMethodReturn(Object o, String owner, String name, String desc){
		if (guardIn()) return;
		handler.onMethodReturn(o, owner, name, desc);
		guardOut();
	}*/
	
	public static void onCast(Object o, String type) {
		if (guardIn()) return;
		handler.onCast(o, type);
		guardOut();
	}

}
