package jbox.util;

public class Pair<X,Y> {
	X x;
	Y y;

	public Pair() {
		
	}
	
	public Pair(X x, Y y) {
		this.x = x; this.y = y;
	}

	public X getX() {
		return x;
	}

	public Y getY() {
		return y;
	}

	public boolean equals(Object o) {
		return (o instanceof Pair && x.equals(((Pair<X,Y>)o).x)) && y.equals(((Pair<X,Y>)o).y);
	}

	public String toString() {
		return x + " , " + y;
	}

	public void setX(X x) {
		this.x = x;
	}

	public void setY(Y y) {
		this.y = y;
	}
}

