package jcs.ast.gen;

import katja.common.*;

public interface ExpressionNd extends jcs.ast.gen.JCS.SortNd {

    //----- methods of ExpressionNd -----

    public KatjaSort term();
    public jcs.ast.gen.Expression termExpression();
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.ExpressionNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ExpressionNd -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public CT CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public CT CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public CT CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public CT CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public CT CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public CT CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public CT CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ExpressionNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }
    }
}

