package jcs.ast.gen;

import katja.common.*;

public interface IdentifierOpt extends KatjaSort {

    //----- methods of IdentifierOpt -----

    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierOpt -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseIdentifier(jcs.ast.gen.Identifier term) throws E;
        public CT CaseIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierOpt.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOpt.Switch<Object, E> variantVisit$IdentifierOpt = new jcs.ast.gen.IdentifierOpt.Switch<Object, E>() { public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E { visitIdentifierNone(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E {
            term.Switch(variantVisit$IdentifierOpt);
        }
    }
}

