package jcs.ast.gen;

import katja.common.*;

public interface IdentifierOptNd extends jcs.ast.gen.JCS.SortNd {

    //----- methods of IdentifierOptNd -----

    public KatjaSort term();
    public jcs.ast.gen.IdentifierOpt termIdentifierOpt();
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierOptNd -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public CT CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierOptNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }
    }
}

