package jcs.ast.gen;

import katja.common.*;

public interface TypeOptNd extends jcs.ast.gen.JCS.SortNd {

    //----- methods of TypeOptNd -----

    public KatjaSort term();
    public jcs.ast.gen.TypeOpt termTypeOpt();
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TypeOptNd -----

    public static interface Switch<CT, E extends Throwable> extends jcs.ast.gen.TypeNd.Switch<CT, E> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitTypeOptNd(jcs.ast.gen.TypeOptNd term) throws E;
        public void visitTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.TypeOptNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.TypeOptNd.Switch<Object, E> variantVisit$TypeOptNd = new jcs.ast.gen.TypeOptNd.Switch<Object, E>() { public final Object CaseTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E { visitTypeNoneNd(term); return null; } public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeOptNd);
        }

        public final void visitTypeOptNd(jcs.ast.gen.TypeOptNd term) throws E {
            term.Switch(variantVisit$TypeOptNd);
        }
    }
}

