package katja.spec;

import katja.common.*;

public interface KatjaError extends KatjaSort {

    //----- methods of KatjaError -----

    public java.lang.String message();
    public <CT, E extends Throwable> CT Switch(katja.spec.KatjaError.Switch<CT, E> switchClass) throws E;

    //----- nested classes of KatjaError -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseKatjaSpecError(katja.spec.KatjaSpecError term) throws E;
        public CT CaseKatjaUsageError(katja.spec.KatjaUsageError term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitKatjaError(katja.spec.KatjaError term) throws E;
        public void visitKatjaSpecError(katja.spec.KatjaSpecError term) throws E;
        public void visitKatjaUsageError(katja.spec.KatjaUsageError term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.KatjaError.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.KatjaError.Switch<Object, E> variantVisit$KatjaError = new katja.spec.KatjaError.Switch<Object, E>() { public final Object CaseKatjaSpecError(katja.spec.KatjaSpecError term) throws E { visitKatjaSpecError(term); return null; } public final Object CaseKatjaUsageError(katja.spec.KatjaUsageError term) throws E { visitKatjaUsageError(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitKatjaError(katja.spec.KatjaError term) throws E {
            term.Switch(variantVisit$KatjaError);
        }
    }
}

