package katja.spec;

import katja.common.*;

public interface SelectorOptPos extends katja.spec.Katja.SortPos {

    //----- methods of SelectorOptPos -----

    public KatjaSort term();
    public katja.spec.SelectorOpt termSelectorOpt();
    public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOptPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SelectorOptPos -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseSelectorPos(katja.spec.SelectorPos term) throws E;
        public CT CaseEmptyPos(katja.spec.EmptyPos term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SelectorOptPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }
    }
}

