package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface ListTermSortDescriptors extends KatjaList<katja.spec.descriptors.ListTermSortDescriptor> {

    //----- methods of ListTermSortDescriptors -----

    public katja.spec.descriptors.ListTermSortDescriptors add(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);
    public katja.spec.descriptors.ListTermSortDescriptors remove(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);
    public katja.spec.descriptors.ListTermSortDescriptors appBack(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors appFront(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);
    public katja.spec.descriptors.ListTermSortDescriptors front();
    public katja.spec.descriptors.ListTermSortDescriptors back();
    public katja.spec.descriptors.ListTermSortDescriptors reverse();
    public katja.spec.descriptors.ListTermSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.ListTermSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.ListTermSortDescriptors toSet();
    public katja.spec.descriptors.ListTermSortDescriptors setAdd(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors setRemove(katja.spec.descriptors.ListTermSortDescriptor element);
    public katja.spec.descriptors.ListTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);
    public katja.spec.descriptors.ListTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);
    public katja.spec.descriptors.ListTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list);

    //----- nested classes of ListTermSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitListTermSortDescriptors(katja.spec.descriptors.ListTermSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.ListTermSortDescriptors.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.ListTermSortDescriptor> implements katja.spec.descriptors.ListTermSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.ListTermSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.ListTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ListTermSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.ListTermSortDescriptors createInstance(katja.spec.descriptors.ListTermSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.ListTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ListTermSortDescriptors invoked with null element");

            ListTermSortDescriptors.Impl temp = new katja.spec.descriptors.ListTermSortDescriptors.Impl();
            temp.values = elements;
            temp = (ListTermSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.ListTermSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.ListTermSortDescriptor[size];
        }

        public katja.spec.descriptors.ListTermSortDescriptors add(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.ListTermSortDescriptors remove(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.ListTermSortDescriptors appBack(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors appFront(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.ListTermSortDescriptors front() {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.front();
        }

        public katja.spec.descriptors.ListTermSortDescriptors back() {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.back();
        }

        public katja.spec.descriptors.ListTermSortDescriptors reverse() {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.ListTermSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.ListTermSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors toSet() {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.ListTermSortDescriptors setAdd(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors setRemove(katja.spec.descriptors.ListTermSortDescriptor element) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.ListTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.ListTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.ListTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.ListTermSortDescriptor> list) {
            return (katja.spec.descriptors.ListTermSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.ListTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.ListTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ListTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.ListTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ListTermSortDescriptors";
        }
    }
}

