package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface VariantTermSortDescriptors extends KatjaList<katja.spec.descriptors.VariantTermSortDescriptor> {

    //----- methods of VariantTermSortDescriptors -----

    public katja.spec.descriptors.VariantTermSortDescriptors add(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);
    public katja.spec.descriptors.VariantTermSortDescriptors remove(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);
    public katja.spec.descriptors.VariantTermSortDescriptors appBack(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors appFront(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);
    public katja.spec.descriptors.VariantTermSortDescriptors front();
    public katja.spec.descriptors.VariantTermSortDescriptors back();
    public katja.spec.descriptors.VariantTermSortDescriptors reverse();
    public katja.spec.descriptors.VariantTermSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.VariantTermSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.VariantTermSortDescriptors toSet();
    public katja.spec.descriptors.VariantTermSortDescriptors setAdd(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors setRemove(katja.spec.descriptors.VariantTermSortDescriptor element);
    public katja.spec.descriptors.VariantTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);
    public katja.spec.descriptors.VariantTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);
    public katja.spec.descriptors.VariantTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list);

    //----- nested classes of VariantTermSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitVariantTermSortDescriptors(katja.spec.descriptors.VariantTermSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.VariantTermSortDescriptors.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.VariantTermSortDescriptor> implements katja.spec.descriptors.VariantTermSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.VariantTermSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.VariantTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantTermSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.VariantTermSortDescriptors createInstance(katja.spec.descriptors.VariantTermSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.VariantTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantTermSortDescriptors invoked with null element");

            VariantTermSortDescriptors.Impl temp = new katja.spec.descriptors.VariantTermSortDescriptors.Impl();
            temp.values = elements;
            temp = (VariantTermSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.VariantTermSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.VariantTermSortDescriptor[size];
        }

        public katja.spec.descriptors.VariantTermSortDescriptors add(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors remove(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors appBack(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors appFront(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors front() {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.front();
        }

        public katja.spec.descriptors.VariantTermSortDescriptors back() {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.back();
        }

        public katja.spec.descriptors.VariantTermSortDescriptors reverse() {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.VariantTermSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors toSet() {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.VariantTermSortDescriptors setAdd(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors setRemove(katja.spec.descriptors.VariantTermSortDescriptor element) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.VariantTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.VariantTermSortDescriptor> list) {
            return (katja.spec.descriptors.VariantTermSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.VariantTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.VariantTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("VariantTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.VariantTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "VariantTermSortDescriptors";
        }
    }
}

