package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface IntegerInFile extends katja.spec.model.Model.LeafInFile<java.lang.Integer> {

    //----- methods of IntegerInFile -----

    public java.lang.Integer term();
    public katja.spec.model.SortDescriptorInFile parent();
    public katja.spec.model.StringInFile lsib();
    public katja.spec.model.BooleanInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of IntegerInFile -----

    static class Impl extends KatjaLeafPosImpl<katja.spec.model.MFileInFile, java.lang.Integer> implements katja.spec.model.IntegerInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, java.lang.Integer term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.SortDescriptorInFile parent() {
            return (katja.spec.model.SortDescriptorInFile) super.parent();
        }

        public katja.spec.model.StringInFile lsib() {
            return (katja.spec.model.StringInFile) super.lsib();
        }

        public katja.spec.model.BooleanInFile rsib() {
            return (katja.spec.model.BooleanInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append(term().toString());
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IntegerInFile";
        }
    }
}

