package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MAnyTypes extends KatjaList<katja.spec.model.MAnyType> {

    //----- methods of MAnyTypes -----

    public katja.spec.model.MAnyTypes add(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes addAll(KatjaList<? extends katja.spec.model.MAnyType> list);
    public katja.spec.model.MAnyTypes remove(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes removeAll(KatjaList<? extends katja.spec.model.MAnyType> list);
    public katja.spec.model.MAnyTypes appBack(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes appFront(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes conc(KatjaList<? extends katja.spec.model.MAnyType> list);
    public katja.spec.model.MAnyTypes front();
    public katja.spec.model.MAnyTypes back();
    public katja.spec.model.MAnyTypes reverse();
    public katja.spec.model.MAnyTypes sublist(int from, int to);
    public katja.spec.model.MAnyTypes replace(int ith, Object element);
    public katja.spec.model.MAnyTypes toSet();
    public katja.spec.model.MAnyTypes setAdd(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes setRemove(katja.spec.model.MAnyType element);
    public katja.spec.model.MAnyTypes setUnion(KatjaList<? extends katja.spec.model.MAnyType> list);
    public katja.spec.model.MAnyTypes setIntersection(KatjaList<? extends katja.spec.model.MAnyType> list);
    public katja.spec.model.MAnyTypes setWithout(KatjaList<? extends katja.spec.model.MAnyType> list);

    //----- nested classes of MAnyTypes -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMAnyTypes(katja.spec.model.MAnyTypes term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MAnyTypes.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MAnyType> implements katja.spec.model.MAnyTypes {

        //----- methods of Impl -----

        Impl(katja.spec.model.MAnyType... elements) {
            super(elements);

            for(katja.spec.model.MAnyType element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MAnyTypes invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MAnyTypes createInstance(katja.spec.model.MAnyType[] elements, boolean isSet) {
            for(katja.spec.model.MAnyType element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MAnyTypes invoked with null element");

            MAnyTypes.Impl temp = new katja.spec.model.MAnyTypes.Impl();
            temp.values = elements;
            temp = (MAnyTypes.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MAnyType[] createArray(int size) {
            return new katja.spec.model.MAnyType[size];
        }

        public katja.spec.model.MAnyTypes add(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.add(element);
        }

        public katja.spec.model.MAnyTypes addAll(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.addAll(list);
        }

        public katja.spec.model.MAnyTypes remove(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.remove(element);
        }

        public katja.spec.model.MAnyTypes removeAll(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.removeAll(list);
        }

        public katja.spec.model.MAnyTypes appBack(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.appBack(element);
        }

        public katja.spec.model.MAnyTypes appFront(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.appFront(element);
        }

        public katja.spec.model.MAnyTypes conc(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.conc(list);
        }

        public katja.spec.model.MAnyTypes front() {
            return (katja.spec.model.MAnyTypes) super.front();
        }

        public katja.spec.model.MAnyTypes back() {
            return (katja.spec.model.MAnyTypes) super.back();
        }

        public katja.spec.model.MAnyTypes reverse() {
            return (katja.spec.model.MAnyTypes) super.reverse();
        }

        public katja.spec.model.MAnyTypes sublist(int from, int to) {
            return (katja.spec.model.MAnyTypes) super.sublist(from, to);
        }

        public katja.spec.model.MAnyTypes replace(int ith, Object element) {
            return (katja.spec.model.MAnyTypes) super.replace(ith, element);
        }

        public katja.spec.model.MAnyTypes toSet() {
            return (katja.spec.model.MAnyTypes) super.toSet();
        }

        public katja.spec.model.MAnyTypes setAdd(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.setAdd(element);
        }

        public katja.spec.model.MAnyTypes setRemove(katja.spec.model.MAnyType element) {
            return (katja.spec.model.MAnyTypes) super.setRemove(element);
        }

        public katja.spec.model.MAnyTypes setUnion(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.setUnion(list);
        }

        public katja.spec.model.MAnyTypes setIntersection(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.setIntersection(list);
        }

        public katja.spec.model.MAnyTypes setWithout(KatjaList<? extends katja.spec.model.MAnyType> list) {
            return (katja.spec.model.MAnyTypes) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MAnyTypes");
            builder.append("( ");
            for(katja.spec.model.MAnyType element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MAnyTypes");
            builder.append("( ");
            for(katja.spec.model.MAnyType element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MAnyTypes";
        }
    }
}

