package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MClasses extends KatjaList<katja.spec.model.MClass> {

    //----- methods of MClasses -----

    public katja.spec.model.MClasses add(katja.spec.model.MClass element);
    public katja.spec.model.MClasses addAll(KatjaList<? extends katja.spec.model.MClass> list);
    public katja.spec.model.MClasses remove(katja.spec.model.MClass element);
    public katja.spec.model.MClasses removeAll(KatjaList<? extends katja.spec.model.MClass> list);
    public katja.spec.model.MClasses appBack(katja.spec.model.MClass element);
    public katja.spec.model.MClasses appFront(katja.spec.model.MClass element);
    public katja.spec.model.MClasses conc(KatjaList<? extends katja.spec.model.MClass> list);
    public katja.spec.model.MClasses front();
    public katja.spec.model.MClasses back();
    public katja.spec.model.MClasses reverse();
    public katja.spec.model.MClasses sublist(int from, int to);
    public katja.spec.model.MClasses replace(int ith, Object element);
    public katja.spec.model.MClasses toSet();
    public katja.spec.model.MClasses setAdd(katja.spec.model.MClass element);
    public katja.spec.model.MClasses setRemove(katja.spec.model.MClass element);
    public katja.spec.model.MClasses setUnion(KatjaList<? extends katja.spec.model.MClass> list);
    public katja.spec.model.MClasses setIntersection(KatjaList<? extends katja.spec.model.MClass> list);
    public katja.spec.model.MClasses setWithout(KatjaList<? extends katja.spec.model.MClass> list);

    //----- nested classes of MClasses -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMClass(katja.spec.model.MClass term) throws E;
        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
        public void visitMClassType(katja.spec.model.MClassType term) throws E;
        public void visitMTypeDef(katja.spec.model.MTypeDef term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMAttributes(katja.spec.model.MAttributes term) throws E;
        public void visitMMethods(katja.spec.model.MMethods term) throws E;
        public void visitMClasses(katja.spec.model.MClasses term) throws E;
        public void visitINTERFACE(katja.spec.model.INTERFACE term) throws E;
        public void visitCLASS(katja.spec.model.CLASS term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMGenericTypeDef(katja.spec.model.MGenericTypeDef term) throws E;
        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMAttribute(katja.spec.model.MAttribute term) throws E;
        public void visitMMethod(katja.spec.model.MMethod term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitMTypeVariables(katja.spec.model.MTypeVariables term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMCodeFragment(katja.spec.model.MCodeFragment term) throws E;
        public void visitMReturnType(katja.spec.model.MReturnType term) throws E;
        public void visitMParameters(katja.spec.model.MParameters term) throws E;
        public void visitMCode(katja.spec.model.MCode term) throws E;
        public void visitMTypeVariable(katja.spec.model.MTypeVariable term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNone(katja.spec.model.MNone term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMParameter(katja.spec.model.MParameter term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E;
        public void visitMParamtype(katja.spec.model.MParamtype term) throws E;
        public void visitMFinal(katja.spec.model.MFinal term) throws E;
        public void visitMVararg(katja.spec.model.MVararg term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MClasses.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MClassType.Switch<Object, E> variantVisit$MClassType = new katja.spec.model.MClassType.Switch<Object, E>() { public final Object CaseINTERFACE(katja.spec.model.INTERFACE term) throws E { visitINTERFACE(term); return null; } public final Object CaseCLASS(katja.spec.model.CLASS term) throws E { visitCLASS(term); return null; } };
        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };
        private final katja.spec.model.MParamtype.Switch<Object, E> variantVisit$MParamtype = new katja.spec.model.MParamtype.Switch<Object, E>() { public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtypeDecl.Switch<Object, E> variantVisit$MParamtypeDecl = new katja.spec.model.MParamtypeDecl.Switch<Object, E>() { public final Object CaseMFinal(katja.spec.model.MFinal term) throws E { visitMFinal(term); return null; } public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MReturnType.Switch<Object, E> variantVisit$MReturnType = new katja.spec.model.MReturnType.Switch<Object, E>() { public final Object CaseMNone(katja.spec.model.MNone term) throws E { visitMNone(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeDef.Switch<Object, E> variantVisit$MTypeDef = new katja.spec.model.MTypeDef.Switch<Object, E>() { public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMGenericTypeDef(katja.spec.model.MGenericTypeDef term) throws E { visitMGenericTypeDef(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMClassType(katja.spec.model.MClassType term) throws E {
            term.Switch(variantVisit$MClassType);
        }

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMParamtype(katja.spec.model.MParamtype term) throws E {
            term.Switch(variantVisit$MParamtype);
        }

        public final void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMReturnType(katja.spec.model.MReturnType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMTypeDef(katja.spec.model.MTypeDef term) throws E {
            term.Switch(variantVisit$MTypeDef);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MClass> implements katja.spec.model.MClasses {

        //----- methods of Impl -----

        Impl(katja.spec.model.MClass... elements) {
            super(elements);

            for(katja.spec.model.MClass element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MClasses invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MClasses createInstance(katja.spec.model.MClass[] elements, boolean isSet) {
            for(katja.spec.model.MClass element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MClasses invoked with null element");

            MClasses.Impl temp = new katja.spec.model.MClasses.Impl();
            temp.values = elements;
            temp = (MClasses.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MClass[] createArray(int size) {
            return new katja.spec.model.MClass[size];
        }

        public katja.spec.model.MClasses add(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.add(element);
        }

        public katja.spec.model.MClasses addAll(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.addAll(list);
        }

        public katja.spec.model.MClasses remove(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.remove(element);
        }

        public katja.spec.model.MClasses removeAll(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.removeAll(list);
        }

        public katja.spec.model.MClasses appBack(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.appBack(element);
        }

        public katja.spec.model.MClasses appFront(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.appFront(element);
        }

        public katja.spec.model.MClasses conc(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.conc(list);
        }

        public katja.spec.model.MClasses front() {
            return (katja.spec.model.MClasses) super.front();
        }

        public katja.spec.model.MClasses back() {
            return (katja.spec.model.MClasses) super.back();
        }

        public katja.spec.model.MClasses reverse() {
            return (katja.spec.model.MClasses) super.reverse();
        }

        public katja.spec.model.MClasses sublist(int from, int to) {
            return (katja.spec.model.MClasses) super.sublist(from, to);
        }

        public katja.spec.model.MClasses replace(int ith, Object element) {
            return (katja.spec.model.MClasses) super.replace(ith, element);
        }

        public katja.spec.model.MClasses toSet() {
            return (katja.spec.model.MClasses) super.toSet();
        }

        public katja.spec.model.MClasses setAdd(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.setAdd(element);
        }

        public katja.spec.model.MClasses setRemove(katja.spec.model.MClass element) {
            return (katja.spec.model.MClasses) super.setRemove(element);
        }

        public katja.spec.model.MClasses setUnion(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.setUnion(list);
        }

        public katja.spec.model.MClasses setIntersection(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.setIntersection(list);
        }

        public katja.spec.model.MClasses setWithout(KatjaList<? extends katja.spec.model.MClass> list) {
            return (katja.spec.model.MClasses) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MClasses");
            builder.append("( ");
            for(katja.spec.model.MClass element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MClasses");
            builder.append("( ");
            for(katja.spec.model.MClass element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MClasses";
        }
    }
}

