package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MInnerTypeInFile extends katja.spec.model.MNonGenericTypeInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MInnerType> {

    //----- methods of MInnerTypeInFile -----

    public katja.spec.model.MInnerType termMNonGenericType();
    public katja.spec.model.MInnerType termMType();
    public katja.spec.model.MInnerType termMAnyType();
    public katja.spec.model.MInnerType termMTypeOrWildcard();
    public katja.spec.model.MInnerType termMParamtype();
    public katja.spec.model.MInnerType termMReturnType();
    public katja.spec.model.MInnerType termMParamtypeDecl();
    public katja.spec.model.MInnerType term();
    public katja.spec.model.MNonGenericTypeInFile outerClass();
    public katja.spec.model.MInnerTypeInFile replaceOuterClass(katja.spec.model.MNonGenericType outerClass);
    public katja.spec.model.StringInFile innerClass();
    public katja.spec.model.MInnerTypeInFile replaceInnerClass(java.lang.String innerClass);
    public katja.spec.model.Model.SortInFile get(int i);
    public int size();
    public katja.spec.model.MInnerTypeInFile replace(katja.spec.model.MInnerType term);
    public katja.spec.model.Model.NodeInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MInnerTypeInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MInnerTypeInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MNonGenericTypeInFile.Switch<Object, E> variantVisit$MNonGenericTypeInFile = new katja.spec.model.MNonGenericTypeInFile.Switch<Object, E>() { public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MNonGenericTypeInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MInnerType> implements katja.spec.model.MInnerTypeInFile {

        //----- attributes of Impl -----

        private katja.spec.model.MNonGenericTypeInFile _outerClass = null;
        private katja.spec.model.StringInFile _innerClass = null;

        //----- methods of Impl -----

        public katja.spec.model.MInnerType termMNonGenericType() {
            return term();
        }

        public katja.spec.model.MInnerType termMType() {
            return term();
        }

        public katja.spec.model.MInnerType termMAnyType() {
            return term();
        }

        public katja.spec.model.MInnerType termMTypeOrWildcard() {
            return term();
        }

        public katja.spec.model.MInnerType termMParamtype() {
            return term();
        }

        public katja.spec.model.MInnerType termMReturnType() {
            return term();
        }

        public katja.spec.model.MInnerType termMParamtypeDecl() {
            return term();
        }

        public katja.spec.model.MNonGenericTypeInFile outerClass() {
            if(_outerClass == null)
                _outerClass = katja.spec.model.Model.MNonGenericTypeInFile(this, _term.outerClass(), 0);

            return _outerClass;
        }

        public katja.spec.model.MInnerTypeInFile replaceOuterClass(katja.spec.model.MNonGenericType outerClass) {
            return replace(_term.replaceOuterClass(outerClass));
        }

        public katja.spec.model.StringInFile innerClass() {
            if(_innerClass == null)
                _innerClass = katja.spec.model.Model.StringInFile(this, _term.innerClass(), 1);

            return _innerClass;
        }

        public katja.spec.model.MInnerTypeInFile replaceInnerClass(java.lang.String innerClass) {
            return replace(_term.replaceInnerClass(innerClass));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MInnerType term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.SortInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_outerClass == null)
                        _outerClass = Model.MNonGenericTypeInFile(this, _term.outerClass(), 0);
                    
                    return _outerClass;
                case 1:
                    if(_innerClass == null)
                        _innerClass = Model.StringInFile(this, _term.innerClass(), 1);
                    
                    return _innerClass;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MInnerTypeInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MInnerTypeInFile invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MInnerTypeInFile replace(katja.spec.model.MInnerType term) {
            return (katja.spec.model.MInnerTypeInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.NodeInFile<?> parent() {
            return (katja.spec.model.Model.NodeInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerTypeInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MInnerTypeInFile";
        }
    }
}

