package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MNoneInFile extends katja.spec.model.MReturnTypeInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MNone> {

    //----- methods of MNoneInFile -----

    public katja.spec.model.MNone termMReturnType();
    public katja.spec.model.MNone term();
    public KatjaSortPos<katja.spec.model.MFileInFile> get(int i);
    public int size();
    public katja.spec.model.MNoneInFile replace(katja.spec.model.MNone term);
    public katja.spec.model.MMethodInFile parent();
    public katja.spec.model.MTypeVariablesInFile lsib();
    public katja.spec.model.StringInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MNoneInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMNoneInFile(katja.spec.model.MNoneInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MNoneInFile.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MNone> implements katja.spec.model.MNoneInFile {

        //----- methods of Impl -----

        public katja.spec.model.MNone termMReturnType() {
            return term();
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MNone term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<katja.spec.model.MFileInFile> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MNoneInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MNoneInFile invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.model.MNoneInFile replace(katja.spec.model.MNone term) {
            return (katja.spec.model.MNoneInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MMethodInFile parent() {
            return (katja.spec.model.MMethodInFile) super.parent();
        }

        public katja.spec.model.MTypeVariablesInFile lsib() {
            return (katja.spec.model.MTypeVariablesInFile) super.lsib();
        }

        public katja.spec.model.StringInFile rsib() {
            return (katja.spec.model.StringInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMNoneInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MNoneInFile";
        }
    }
}

