package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface PROTECTED extends katja.spec.model.MModifier, KatjaTuple {

    //----- methods of PROTECTED -----

    public Object get(int i);
    public int size();
    public katja.spec.model.PROTECTED replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MModifier.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PROTECTED -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.PROTECTED.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.PROTECTED {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PROTECTED invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PROTECTED invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.model.PROTECTED replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort PROTECTED invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort PROTECTED invoked with too large parameter "+pos+", sort has only 0 components");


            return (katja.spec.model.PROTECTED) Model.unique(new katja.spec.model.PROTECTED.Impl(
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MModifier.Switch<CT, E> switchClass) throws E {
            return switchClass.CasePROTECTED(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.PROTECTED");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("PROTECTED");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PROTECTED";
        }
    }
}

